diff --git a/arch/Kconfig b/arch/Kconfig
index 51d46a45fef1..b074cc6c51eb 100644
--- a/arch/Kconfig
+++ b/arch/Kconfig
@@ -113,7 +113,6 @@ config RISCV
 	select DM
 	select SPL_SEPARATE_BSS if SPL
 	imply DM_SERIAL
-	imply DM_ETH
 	imply DM_EVENT
 	imply DM_MMC
 	imply DM_SPI
@@ -241,7 +240,6 @@ config X86
 	imply CMD_SF
 	imply CMD_SF_TEST
 	imply CMD_ZBOOT
-	imply DM_ETH
 	imply DM_EVENT
 	imply DM_GPIO
 	imply DM_KEYBOARD
diff --git a/arch/arm/Kconfig b/arch/arm/Kconfig
index 1c734fa08774..f55113fb5c8b 100644
--- a/arch/arm/Kconfig
+++ b/arch/arm/Kconfig
@@ -632,7 +632,6 @@ config ARCH_KIRKWOOD
 config ARCH_MVEBU
 	bool "Marvell MVEBU family (Armada XP/375/38x/3700/7K/8K)"
 	select DM
-	select DM_ETH
 	select DM_SERIAL
 	select DM_SPI
 	select DM_SPI_FLASH
@@ -736,7 +735,6 @@ config ARCH_EXYNOS
 	select DM
 	select DM_GPIO
 	select DM_I2C
-	select DM_ETH
 	select DM_KEYBOARD
 	select DM_SERIAL
 	select DM_SPI
@@ -767,7 +765,6 @@ config ARCH_HIGHBANK
 	select CLK
 	select CLK_CCF
 	select AHCI
-	select DM_ETH
 	select PHYS_64BIT
 	select TIMER
 	select SP804_TIMER
@@ -1041,7 +1038,6 @@ config ARCH_APPLE
 config ARCH_OWL
 	bool "Actions Semi OWL SoCs"
 	select DM
-	select DM_ETH
 	select DM_SERIAL
 	select GPIO_EXTRA_HEADER
 	select OWL_SERIAL
@@ -1141,7 +1137,6 @@ config ARCH_SUNXI
 	select CMD_USB if DISTRO_DEFAULTS && USB_HOST
 	select CLK
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C if I2C
 	select DM_SPI if SPI
@@ -1220,7 +1215,6 @@ config ARCH_VERSAL
 	select ARM64
 	select CLK
 	select DM
-	select DM_ETH if NET
 	select DM_MMC if MMC
 	select DM_SERIAL
 	select GICV3
@@ -1234,7 +1228,6 @@ config ARCH_VERSAL_NET
 	select ARM64
 	select CLK
 	select DM
-	select DM_ETH if NET
 	select DM_MMC if MMC
 	select DM_SERIAL
 	select OF_CONTROL
@@ -1259,7 +1252,6 @@ config ARCH_ZYNQ
 	select CPU_V7A
 	select DEBUG_UART_BOARD_INIT if SPL && DEBUG_UART
 	select DM
-	select DM_ETH if NET
 	select DM_MMC if MMC
 	select DM_SERIAL
 	select DM_SPI
@@ -1289,7 +1281,6 @@ config ARCH_ZYNQMP_R5
 	select CLK
 	select CPU_V7R
 	select DM
-	select DM_ETH if NET
 	select DM_MMC if MMC
 	select DM_SERIAL
 	select OF_CONTROL
@@ -1302,7 +1293,6 @@ config ARCH_ZYNQMP
 	select CLK
 	select DM
 	select DEBUG_UART_BOARD_INIT if SPL && DEBUG_UART
-	select DM_ETH if NET
 	select DM_MAILBOX
 	select DM_MMC if MMC
 	select DM_SERIAL
@@ -1849,7 +1839,6 @@ config TARGET_SL28
 	select DM_I2C
 	select DM_MMC
 	select DM_SPI_FLASH
-	select DM_ETH
 	select DM_MDIO
 	select PCI
 	select DM_RNG
@@ -1886,7 +1875,6 @@ config ARCH_UNIPHIER
 	bool "Socionext UniPhier SoCs"
 	select BOARD_LATE_INIT
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C
 	select DM_MMC
@@ -2072,7 +2060,6 @@ config TARGET_POMELO
 	select SCSI
 	select DM_SCSI
 	select DM_SERIAL
-	select DM_ETH if NET
 	imply CMD_PCI
 	help
 	   Support for pomelo platform.
diff --git a/arch/arm/mach-at91/Kconfig b/arch/arm/mach-at91/Kconfig
index 094c9891f648..7c2e4ebbdb0f 100644
--- a/arch/arm/mach-at91/Kconfig
+++ b/arch/arm/mach-at91/Kconfig
@@ -85,7 +85,6 @@ config TARGET_GURNARD
 	select AT91_WANTS_COMMON_PHY
 	select BOARD_LATE_INIT
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_SERIAL
 	select DM_SPI
@@ -253,7 +252,6 @@ config TARGET_CORVUS
 	select AT91SAM9M10G45
 	select AT91_WANTS_COMMON_PHY
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_SERIAL
 	select SUPPORT_SPL
@@ -271,7 +269,6 @@ config TARGET_TAURUS
 	select AT91SAM9G20
 	select AT91_WANTS_COMMON_PHY
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_SERIAL
 	select DM_SPI
@@ -284,7 +281,6 @@ config TARGET_SMARTWEB
 	select AT91SAM9260
 	select AT91_WANTS_COMMON_PHY
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_SERIAL
 	select SUPPORT_SPL
diff --git a/arch/arm/mach-imx/mx5/Kconfig b/arch/arm/mach-imx/mx5/Kconfig
index 494e2136dc04..d282663dcf1f 100644
--- a/arch/arm/mach-imx/mx5/Kconfig
+++ b/arch/arm/mach-imx/mx5/Kconfig
@@ -22,7 +22,6 @@ config TARGET_KP_IMX53
 	bool "Support K+P imx53 board"
 	select BOARD_LATE_INIT
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C
 	select DM_PMIC
diff --git a/arch/arm/mach-imx/mx6/Kconfig b/arch/arm/mach-imx/mx6/Kconfig
index e6b0ee757933..7529b311f80e 100644
--- a/arch/arm/mach-imx/mx6/Kconfig
+++ b/arch/arm/mach-imx/mx6/Kconfig
@@ -174,7 +174,6 @@ config TARGET_DART_6UL
 	bool "Variscite imx6ULL dart(DART-SOM-6ULL)"
 	depends on MX6ULL
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C
 	select DM_MMC
@@ -197,7 +196,6 @@ config TARGET_DISPLAY5
 	bool "LWN DISPLAY5 board"
 	depends on MX6Q
 	select DM
-	select DM_ETH
 	select DM_I2C
 	select DM_MMC
 	select DM_SPI
@@ -245,7 +243,6 @@ config TARGET_KONTRON_MX6UL
 config TARGET_KOSAGI_NOVENA
 	bool "Kosagi Novena"
 	select BOARD_LATE_INIT
-	select DM_ETH
 	select DM_GPIO
 	select DM_MMC
 	select PCI
@@ -261,7 +258,6 @@ config TARGET_MCCMON6
 	select SUPPORT_SPL
 	select DM
 	select DM_GPIO
-	select DM_ETH
 	select DM_SERIAL
 	select DM_I2C
 	select DM_SPI
@@ -280,7 +276,6 @@ config TARGET_MX6LOGICPD
 	select BOARD_EARLY_INIT_F
 	select BOARD_LATE_INIT
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C
 	select DM_MMC
@@ -301,7 +296,6 @@ config TARGET_MX6DL_MAMOJ
 	bool "Support BTicino Mamoj"
 	depends on MX6QDL
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C
 	select DM_MMC
@@ -334,7 +328,6 @@ config TARGET_MX6Q_ENGICAM
 	depends on MX6QDL
 	select BOARD_LATE_INIT
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C
 	select DM_MMC
@@ -355,7 +348,6 @@ config TARGET_MX6Q_ACC
 	select OF_CONTROL
 	select SPL_OF_LIBFDT
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C
 	select DM_MMC
@@ -447,7 +439,6 @@ config TARGET_MX6UL_ENGICAM
 	depends on MX6UL
 	select BOARD_LATE_INIT
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C
 	select DM_MMC
@@ -484,7 +475,6 @@ config TARGET_MYS_6ULX
 	bool "MYiR MYS-6ULX"
 	depends on MX6ULL
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C
 	select DM_MMC
@@ -504,7 +494,6 @@ config TARGET_NPI_IMX6ULL
 	bool "Seeed NPI-IMX6ULL"
 	depends on MX6ULL
 	select DM
-	select DM_ETH
 	select DM_MMC
 	select DM_GPIO
 	select DM_SERIAL
@@ -552,7 +541,6 @@ config TARGET_PCL063
 	bool "PHYTEC PCL063 (phyCORE-i.MX6UL)"
 	depends on MX6UL
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C
 	select DM_MMC
@@ -564,7 +552,6 @@ config TARGET_PCL063_ULL
 	bool "PHYTEC PCL063 (phyCORE-i.MX6ULL)"
 	depends on MX6ULL
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C
 	select DM_MMC
@@ -577,7 +564,6 @@ config TARGET_SOMLABS_VISIONSOM_6ULL
 	depends on MX6ULL
 	select BOARD_LATE_INIT
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_MMC
 	select DM_SERIAL
@@ -597,7 +583,6 @@ config TARGET_KP_IMX6Q_TPC
 	select SPL_DM if SPL
 	select DM_THERMAL
 	select DM_MMC
-	select DM_ETH
 	select DM_REGULATOR
 	select SPL_DM_REGULATOR if SPL
 	select DM_SERIAL
@@ -661,7 +646,6 @@ config TARGET_BRPPT2
 	select OF_CONTROL
 	select SPL_OF_LIBFDT
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C
 	select DM_MMC
diff --git a/arch/arm/mach-omap2/am33xx/Kconfig b/arch/arm/mach-omap2/am33xx/Kconfig
index 6c2d46abc4cf..b666e8111040 100644
--- a/arch/arm/mach-omap2/am33xx/Kconfig
+++ b/arch/arm/mach-omap2/am33xx/Kconfig
@@ -230,7 +230,6 @@ config TARGET_AM43XX_EVM
 	bool "Support am43xx_evm"
 	select BOARD_LATE_INIT
 	select TI_I2C_BOARD_DETECT
-	imply DM_ETH
 	imply DM_I2C
 	imply DM_SPI
 	imply DM_SPI_FLASH
diff --git a/arch/arm/mach-snapdragon/Kconfig b/arch/arm/mach-snapdragon/Kconfig
index 092733330683..914f4d960534 100644
--- a/arch/arm/mach-snapdragon/Kconfig
+++ b/arch/arm/mach-snapdragon/Kconfig
@@ -55,7 +55,6 @@ config TARGET_DRAGONBOARD845C
 	  - 64GiB UFS drive
 	select MISC_INIT_R
 	select SDM845
-	select DM_ETH if NET
 
 config TARGET_STARQLTECHN
 	bool "Samsung S9 SM-G9600(starqltechn)"
@@ -67,7 +66,6 @@ config TARGET_STARQLTECHN
 	  - 64GiB UFS drive
 	select MISC_INIT_R
 	select SDM845
-	select DM_ETH if NET
 
 config TARGET_QCS404EVB
 	bool "Qualcomm Technologies, Inc. QCS404 EVB"
diff --git a/arch/arm/mach-tegra/Kconfig b/arch/arm/mach-tegra/Kconfig
index 09ad2d6f5aec..edcf967afd96 100644
--- a/arch/arm/mach-tegra/Kconfig
+++ b/arch/arm/mach-tegra/Kconfig
@@ -44,7 +44,6 @@ config TEGRA_COMMON
 	select BOARD_EARLY_INIT_F
 	select CLK
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C
 	select DM_KEYBOARD
diff --git a/arch/mips/Kconfig b/arch/mips/Kconfig
index 9af0133f1068..23142bd2700d 100644
--- a/arch/mips/Kconfig
+++ b/arch/mips/Kconfig
@@ -19,7 +19,6 @@ config TARGET_MALTA
 	select DM
 	select DM_SERIAL
 	select PCI
-	select DM_ETH
 	select DYNAMIC_IO_PORT_BASE
 	select MIPS_CM
 	select MIPS_INSERT_BOOT_CONFIG
@@ -71,7 +70,6 @@ config ARCH_MTMIPS
 	imply CMD_DM
 	select DISPLAY_CPUINFO
 	select DM
-	imply DM_ETH
 	imply DM_GPIO
 	select DM_RESET
 	select DM_SERIAL
@@ -104,7 +102,6 @@ config ARCH_OCTEON
 	select DISPLAY_CPUINFO
 	select DMA_ADDR_T_64BIT
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_I2C
 	select DM_SERIAL
@@ -153,7 +150,6 @@ config TARGET_XILFPGA
 	bool "Support Imagination Xilfpga"
 	select HAS_FIXED_TIMER_FREQUENCY
 	select DM
-	select DM_ETH
 	select DM_GPIO
 	select DM_SERIAL
 	select SYS_CACHE_SHIFT_4
diff --git a/board/armltd/vexpress64/Kconfig b/board/armltd/vexpress64/Kconfig
index c7adae0ea717..5616e223a90a 100644
--- a/board/armltd/vexpress64/Kconfig
+++ b/board/armltd/vexpress64/Kconfig
@@ -14,7 +14,6 @@ config VEXPRESS64_BASE_MODEL
 	select SEMIHOSTING
 	select VIRTIO_BLK if VIRTIO_MMIO
 	select VIRTIO_NET if VIRTIO_MMIO
-	select DM_ETH if VIRTIO_NET
 	select LINUX_KERNEL_IMAGE_HEADER
 	select POSITION_INDEPENDENT
 
diff --git a/board/keymile/km83xx/Kconfig b/board/keymile/km83xx/Kconfig
index ef3c62b9ded6..f87a2e64163e 100644
--- a/board/keymile/km83xx/Kconfig
+++ b/board/keymile/km83xx/Kconfig
@@ -6,7 +6,6 @@ config KM_ENABLE_FULL_DM_DTS_SUPPORT
 	default y
 	select CMD_DM
 	select DM
-	select DM_ETH
 	select DM_MDIO
 	select DM_SERIAL
 	select OF_CONTROL
diff --git a/board/tq/tqma6/Kconfig b/board/tq/tqma6/Kconfig
index 1cd90718f4a1..e7f23367afd2 100644
--- a/board/tq/tqma6/Kconfig
+++ b/board/tq/tqma6/Kconfig
@@ -63,7 +63,6 @@ choice
 
 config MBA6
 	bool "TQMa6 on MBa6 Starterkit"
-	select DM_ETH
 	select USB
 	select CMD_USB
 	select USB_STORAGE