diff --git a/arch/Kconfig b/arch/Kconfig
index d30676ae817..3b95fbe9b36 100644
--- a/arch/Kconfig
+++ b/arch/Kconfig
@@ -53,8 +53,8 @@ config ARC
 	select SUPPORT_OF_CONTROL
 	select SYS_CACHE_SHIFT_7
 	select TIMER
-	select SYS_BIG_ENDIAN if CPU_BIG_ENDIAN
-	select SYS_LITTLE_ENDIAN if !CPU_BIG_ENDIAN
+	# select SYS_BIG_ENDIAN if CPU_BIG_ENDIAN
+	# select SYS_LITTLE_ENDIAN if !CPU_BIG_ENDIAN
 
 config ARM
 	bool "ARM architecture"
diff --git a/arch/arc/Kconfig b/arch/arc/Kconfig
index 6ae66bb163c..8c0d1c8a3ee 100644
--- a/arch/arc/Kconfig
+++ b/arch/arc/Kconfig
@@ -32,35 +32,35 @@ choice
 config CPU_ARC750D
 	bool "ARC 750D"
 	depends on ISA_ARCOMPACT
-	select ARC_MMU_V2
+	# select ARC_MMU_V2
 	help
 	  Choose this option to build an U-Boot for ARC750D CPU.
 
 config CPU_ARC770D
 	bool "ARC 770D"
 	depends on ISA_ARCOMPACT
-	select ARC_MMU_V3
+	# select ARC_MMU_V3
 	help
 	  Choose this option to build an U-Boot for ARC770D CPU.
 
 config CPU_ARCEM6
 	bool "ARC EM6"
 	depends on ISA_ARCV2
-	select ARC_MMU_ABSENT
+	# select ARC_MMU_ABSENT
 	help
 	  Next Generation ARC Core based on ISA-v2 ISA without MMU.
 
 config CPU_ARCHS36
 	bool "ARC HS36"
 	depends on ISA_ARCV2
-	select ARC_MMU_ABSENT
+	# select ARC_MMU_ABSENT
 	help
 	  Next Generation ARC Core based on ISA-v2 ISA without MMU.
 
 config CPU_ARCHS38
 	bool "ARC HS38"
 	depends on ISA_ARCV2
-	select ARC_MMU_V4
+	# select ARC_MMU_V4
 	help
 	  Next Generation ARC Core based on ISA-v2 ISA with MMU.
 
@@ -172,14 +172,14 @@ config TARGET_AXS103
 
 config TARGET_EMSDP
 	bool "Synopsys EM Software Development Platform"
-	select CPU_ARCEM6
+	# select CPU_ARCEM6
 
 config TARGET_HSDK
 	bool "Support Synopsys HSDK or HSDK-4xD board"
 
 config TARGET_IOT_DEVKIT
 	bool "Synopsys Brite IoT Development kit"
-	select CPU_ARCEM6
+	# select CPU_ARCEM6
 
 endchoice
 
diff --git a/arch/arm/Kconfig b/arch/arm/Kconfig
index c9a44ebc221..b18af584770 100644
--- a/arch/arm/Kconfig
+++ b/arch/arm/Kconfig
@@ -598,7 +598,7 @@ config ARCH_MVEBU
 	select SPL_TIMER if SPL
 	select TIMER if !ARM64
 	select OF_CONTROL
-	select OF_SEPARATE
+	# select OF_SEPARATE
 	select SPI
 	imply CMD_DM
 
@@ -1038,7 +1038,7 @@ config ARCH_SNAPDRAGON
 	select GPIO_EXTRA_HEADER
 	select MSM_SMEM
 	select OF_CONTROL
-	select OF_SEPARATE
+	# select OF_SEPARATE
 	select SMEM
 	select SPMI
 	imply CMD_DM
@@ -1107,7 +1107,7 @@ config ARCH_SUNXI
 	select GPIO_EXTRA_HEADER
 	select OF_BOARD_SETUP
 	select OF_CONTROL
-	select OF_SEPARATE
+	# select OF_SEPARATE
 	select PINCTRL
 	select SPECIFY_CONSOLE_INDEX
 	select SPL_SEPARATE_BSS if SPL
diff --git a/arch/arm/mach-nexell/Kconfig b/arch/arm/mach-nexell/Kconfig
index 16324e15206..fd6c7774f68 100644
--- a/arch/arm/mach-nexell/Kconfig
+++ b/arch/arm/mach-nexell/Kconfig
@@ -4,7 +4,7 @@ config ARCH_S5P4418
 	bool "Nexell S5P4418 SoC"
 	select CPU_V7A
 	select OF_CONTROL
-	select OF_SEPARATE
+	# select OF_SEPARATE
 	select NX_GPIO
 	select DM_SERIAL
 	select PL01X_SERIAL
diff --git a/arch/arm/mach-rmobile/Kconfig.64 b/arch/arm/mach-rmobile/Kconfig.64
index 007eaad251d..0e8a49deeb6 100644
--- a/arch/arm/mach-rmobile/Kconfig.64
+++ b/arch/arm/mach-rmobile/Kconfig.64
@@ -93,7 +93,7 @@ config TARGET_BEACON_RZG2M
 	select PINCTRL_PFC_R8A774B1
 	select PINCTRL_PFC_R8A774E1
 	imply MULTI_DTB_FIT
-	imply MULTI_DTB_FIT_USER_DEFINED_AREA
+	# imply MULTI_DTB_FIT_USER_DEFINED_AREA
 	imply CLK_VERSACLOCK
 	imply CLK_CCF
 
@@ -135,7 +135,7 @@ config TARGET_HIHOPE_RZG2
 	imply RZ_G2
 	imply SYS_MALLOC_F
 	imply MULTI_DTB_FIT
-	imply MULTI_DTB_FIT_USER_DEFINED_AREA
+	# imply MULTI_DTB_FIT_USER_DEFINED_AREA
 	help
           Support for RZG2 HiHope platform
 
@@ -153,7 +153,7 @@ config TARGET_SALVATOR_X
 	imply R8A77965
 	imply SYS_MALLOC_F
 	imply MULTI_DTB_FIT
-	imply MULTI_DTB_FIT_USER_DEFINED_AREA
+	# imply MULTI_DTB_FIT_USER_DEFINED_AREA
 	help
           Support for Renesas R-Car Gen3 platform
 
@@ -164,7 +164,7 @@ config TARGET_ULCB
 	imply R8A77965
 	imply SYS_MALLOC_F
 	imply MULTI_DTB_FIT
-	imply MULTI_DTB_FIT_USER_DEFINED_AREA
+	# imply MULTI_DTB_FIT_USER_DEFINED_AREA
 	help
           Support for Renesas R-Car Gen3 ULCB platform
 
diff --git a/arch/arm/mach-rockchip/rv1108/Kconfig b/arch/arm/mach-rockchip/rv1108/Kconfig
index a12216dccf6..28ed0b24581 100644
--- a/arch/arm/mach-rockchip/rv1108/Kconfig
+++ b/arch/arm/mach-rockchip/rv1108/Kconfig
@@ -36,7 +36,7 @@ config SYS_SOC
 config SYS_MALLOC_F_LEN
 	default 0x400
 
-source board/rockchip/evb_rv1108/Kconfig
-source board/elgin/elgin_rv1108/Kconfig
+source "board/rockchip/evb_rv1108/Kconfig"
+source "board/elgin/elgin_rv1108/Kconfig"
 
 endif
diff --git a/arch/arm/mach-rockchip/rv1126/Kconfig b/arch/arm/mach-rockchip/rv1126/Kconfig
index 7382c559966..e13d4093688 100644
--- a/arch/arm/mach-rockchip/rv1126/Kconfig
+++ b/arch/arm/mach-rockchip/rv1126/Kconfig
@@ -54,6 +54,6 @@ config SYS_MALLOC_F_LEN
 config TEXT_BASE
 	default 0x600000
 
-source board/edgeble/neural-compute-module-2/Kconfig
+source "board/edgeble/neural-compute-module-2/Kconfig"
 
 endif
diff --git a/arch/x86/cpu/apollolake/Kconfig b/arch/x86/cpu/apollolake/Kconfig
index c7f26d171cb..5fea952188a 100644
--- a/arch/x86/cpu/apollolake/Kconfig
+++ b/arch/x86/cpu/apollolake/Kconfig
@@ -5,7 +5,7 @@
 
 config INTEL_APOLLOLAKE
 	bool
-	select FSP_VERSION2
+	# select FSP_VERSION2
 	select HAVE_FSP
 	select ARCH_MISC_INIT
 	select USE_CAR
diff --git a/board/efi/Kconfig b/board/efi/Kconfig
index 3df6e31c8ba..688cb9d82d2 100644
--- a/board/efi/Kconfig
+++ b/board/efi/Kconfig
@@ -6,7 +6,7 @@ choice
 
 config TARGET_EFI_APP32
 	bool "32-bit efi application"
-	select EFI_APP
+	# select EFI_APP
 	help
 	  This target is used for running U-Boot on top of EFI. In
 	  this case EFI does the early initialisation, and U-Boot
@@ -15,7 +15,7 @@ config TARGET_EFI_APP32
 
 config TARGET_EFI_APP64
 	bool "64-bit efi application"
-	select EFI_APP
+	# select EFI_APP
 	select X86_64
 	help
 	  This target is used for running U-Boot on top of EFI in 64-bit mode.
diff --git a/board/openpiton/riscv64/Kconfig b/board/openpiton/riscv64/Kconfig
index eb0db8a64c8..02ad27309aa 100644
--- a/board/openpiton/riscv64/Kconfig
+++ b/board/openpiton/riscv64/Kconfig
@@ -35,6 +35,6 @@ config BOARD_SPECIFIC_OPTIONS # dummy
 	imply SPL_SMP
 	imply SPL_MMC
 	imply SMP
-	imply SPL_RISCV_MMODE
+	# imply SPL_RISCV_MMODE
 
 endif
diff --git a/board/siemens/iot2050/Kconfig b/board/siemens/iot2050/Kconfig
index 063142a43bf..096102bd370 100644
--- a/board/siemens/iot2050/Kconfig
+++ b/board/siemens/iot2050/Kconfig
@@ -9,7 +9,7 @@
 config TARGET_IOT2050_A53
 	bool "IOT2050 running on A53"
 	select ARM64
-	select SOC_K3_AM654
+	# select SOC_K3_AM654
 	select BOARD_LATE_INIT
 	select SYS_DISABLE_DCACHE_OPS
 	select BINMAN
diff --git a/board/ti/am62ax/Kconfig b/board/ti/am62ax/Kconfig
index 2c18cd49b5d..db3bdc5f35c 100644
--- a/board/ti/am62ax/Kconfig
+++ b/board/ti/am62ax/Kconfig
@@ -10,7 +10,7 @@ choice
 config TARGET_AM62A7_A53_EVM
 	bool "TI K3 based AM62A7 EVM running on A53"
 	select ARM64
-	select SOC_K3_AM62A7
+	# select SOC_K3_AM62A7
 	imply BOARD
 	imply SPL_BOARD
 	imply TI_I2C_BOARD_DETECT
@@ -20,7 +20,7 @@ config TARGET_AM62A7_R5_EVM
 	select CPU_V7R
 	select SYS_THUMB_BUILD
 	select K3_LOAD_SYSFW
-	select SOC_K3_AM62A7
+	# select SOC_K3_AM62A7
 	select RAM
 	select SPL_RAM
 	select K3_DDRSS
diff --git a/board/ti/am62x/Kconfig b/board/ti/am62x/Kconfig
index 87fed44df17..090ece3315a 100644
--- a/board/ti/am62x/Kconfig
+++ b/board/ti/am62x/Kconfig
@@ -10,14 +10,14 @@ choice
 config TARGET_AM625_A53_EVM
 	bool "TI K3 based AM625 EVM running on A53"
 	select ARM64
-	select SOC_K3_AM625
+	# select SOC_K3_AM625
 
 config TARGET_AM625_R5_EVM
 	bool "TI K3 based AM625 EVM running on R5"
 	select CPU_V7R
 	select SYS_THUMB_BUILD
 	select K3_LOAD_SYSFW
-	select SOC_K3_AM625
+	# select SOC_K3_AM625
 	select RAM
 	select SPL_RAM
 	select K3_DDRSS
diff --git a/board/ti/am64x/Kconfig b/board/ti/am64x/Kconfig
index 8036947e345..f642109686f 100644
--- a/board/ti/am64x/Kconfig
+++ b/board/ti/am64x/Kconfig
@@ -9,7 +9,7 @@ choice
 config TARGET_AM642_A53_EVM
 	bool "TI K3 based AM642 EVM running on A53"
 	select ARM64
-	select SOC_K3_AM642
+	# select SOC_K3_AM642
 	imply BOARD
 	imply SPL_BOARD
 	imply TI_I2C_BOARD_DETECT
@@ -19,7 +19,7 @@ config TARGET_AM642_R5_EVM
 	select CPU_V7R
 	select SYS_THUMB_BUILD
 	select K3_LOAD_SYSFW
-	select SOC_K3_AM642
+	# select SOC_K3_AM642
 	select RAM
 	select SPL_RAM
 	select K3_DDRSS
diff --git a/board/ti/am65x/Kconfig b/board/ti/am65x/Kconfig
index 4765b13ba0c..dcdc46f0b59 100644
--- a/board/ti/am65x/Kconfig
+++ b/board/ti/am65x/Kconfig
@@ -10,7 +10,7 @@ choice
 config TARGET_AM654_A53_EVM
 	bool "TI K3 based AM654 EVM running on A53"
 	select ARM64
-	select SOC_K3_AM654
+	# select SOC_K3_AM654
 	select SYS_DISABLE_DCACHE_OPS
 	select BOARD_LATE_INIT
 	imply TI_I2C_BOARD_DETECT
@@ -19,7 +19,7 @@ config TARGET_AM654_R5_EVM
 	bool "TI K3 based AM654 EVM running on R5"
 	select CPU_V7R
 	select SYS_THUMB_BUILD
-	select SOC_K3_AM654
+	# select SOC_K3_AM654
 	select K3_LOAD_SYSFW
 	select K3_AM654_DDRSS
 	imply SYS_K3_SPL_ATF
diff --git a/board/ti/j721e/Kconfig b/board/ti/j721e/Kconfig
index d19d30d59ef..f997741fe5a 100644
--- a/board/ti/j721e/Kconfig
+++ b/board/ti/j721e/Kconfig
@@ -10,7 +10,7 @@ choice
 config TARGET_J721E_A72_EVM
 	bool "TI K3 based J721E EVM running on A72"
 	select ARM64
-	select SOC_K3_J721E
+	# select SOC_K3_J721E
 	select BOARD_LATE_INIT
 	imply TI_I2C_BOARD_DETECT
 	select SYS_DISABLE_DCACHE_OPS
@@ -19,7 +19,7 @@ config TARGET_J721E_R5_EVM
 	bool "TI K3 based J721E EVM running on R5"
 	select CPU_V7R
 	select SYS_THUMB_BUILD
-	select SOC_K3_J721E
+	# select SOC_K3_J721E
 	select K3_LOAD_SYSFW
 	select RAM
 	select SPL_RAM
@@ -30,7 +30,7 @@ config TARGET_J721E_R5_EVM
 config TARGET_J7200_A72_EVM
 	bool "TI K3 based J7200 EVM running on A72"
 	select ARM64
-	select SOC_K3_J721E
+	# select SOC_K3_J721E
 	select BOARD_LATE_INIT
 	imply TI_I2C_BOARD_DETECT
 	select SYS_DISABLE_DCACHE_OPS
@@ -39,7 +39,7 @@ config TARGET_J7200_R5_EVM
 	bool "TI K3 based J7200 EVM running on R5"
 	select CPU_V7R
 	select SYS_THUMB_BUILD
-	select SOC_K3_J721E
+	# select SOC_K3_J721E
 	select K3_LOAD_SYSFW
 	select RAM
 	select SPL_RAM
diff --git a/board/ti/j721s2/Kconfig b/board/ti/j721s2/Kconfig
index 6141798333c..1631778eaed 100644
--- a/board/ti/j721s2/Kconfig
+++ b/board/ti/j721s2/Kconfig
@@ -10,7 +10,7 @@ choice
 config TARGET_J721S2_A72_EVM
 	bool "TI K3 based J721S2 EVM running on A72"
 	select ARM64
-	select SOC_K3_J721S2
+	# select SOC_K3_J721S2
 	select BOARD_LATE_INIT
 	imply TI_I2C_BOARD_DETECT
 	select SYS_DISABLE_DCACHE_OPS
@@ -19,7 +19,7 @@ config TARGET_J721S2_R5_EVM
 	bool "TI K3 based J721S2 EVM running on R5"
 	select CPU_V7R
 	select SYS_THUMB_BUILD
-	select SOC_K3_J721S2
+	# select SOC_K3_J721S2
 	select K3_LOAD_SYSFW
 	select RAM
 	select SPL_RAM
diff --git a/cmd/Kconfig b/cmd/Kconfig
index 4fe2c75de25..b3c1fcaf6e6 100644
--- a/cmd/Kconfig
+++ b/cmd/Kconfig
@@ -394,7 +394,7 @@ config CMD_BOOTEFI_HELLO
 	  for testing that EFI is working at a basic level, and for bringing
 	  up EFI support on a new architecture.
 
-source lib/efi_selftest/Kconfig
+source "lib/efi_selftest/Kconfig"
 
 config CMD_BOOTMENU
 	bool "bootmenu"
@@ -1876,7 +1876,7 @@ config CMD_DNS
 
 config CMD_LINK_LOCAL
 	bool "linklocal"
-	select LIB_RAND
+	# select LIB_RAND
 	help
 	  Acquire a network IP address using the link-local protocol
 
diff --git a/drivers/clk/Kconfig b/drivers/clk/Kconfig
index 09aa97ee8c0..a7409a0cb34 100644
--- a/drivers/clk/Kconfig
+++ b/drivers/clk/Kconfig
@@ -57,27 +57,27 @@ config CLK_BOSTON
 	  Enable this to support the clocks
 
 config SPL_CLK_CCF
-	bool "SPL Common Clock Framework [CCF] support "
+	bool "SPL Common Clock Framework [CCF] support"
 	depends on SPL
 	help
 	  Enable this option if you want to (re-)use the Linux kernel's Common
 	  Clock Framework [CCF] code in U-Boot's SPL.
 
 config SPL_CLK_COMPOSITE_CCF
-	bool "SPL Common Clock Framework [CCF] composite clk support "
+	bool "SPL Common Clock Framework [CCF] composite clk support"
 	depends on SPL_CLK_CCF
 	help
 	  Enable this option if you want to (re-)use the Linux kernel's Common
 	  Clock Framework [CCF] composite code in U-Boot's SPL.
 
 config CLK_CCF
-	bool "Common Clock Framework [CCF] support "
+	bool "Common Clock Framework [CCF] support"
 	help
 	  Enable this option if you want to (re-)use the Linux kernel's Common
 	  Clock Framework [CCF] code in U-Boot's clock driver.
 
 config CLK_COMPOSITE_CCF
-	bool "Common Clock Framework [CCF] composite clk support "
+	bool "Common Clock Framework [CCF] composite clk support"
 	depends on CLK_CCF
 	help
 	  Enable this option if you want to (re-)use the Linux kernel's Common
@@ -151,7 +151,7 @@ config CLK_OCTEON
 	  Enable this to support the clocks on Octeon MIPS platforms.
 
 config SANDBOX_CLK_CCF
-	bool "Sandbox Common Clock Framework [CCF] support "
+	bool "Sandbox Common Clock Framework [CCF] support"
 	depends on SANDBOX
 	select CLK_CCF
 	help
diff --git a/drivers/crypto/Kconfig b/drivers/crypto/Kconfig
index 12ef84ca05c..8b49997030b 100644
--- a/drivers/crypto/Kconfig
+++ b/drivers/crypto/Kconfig
@@ -1,11 +1,11 @@
 menu "Hardware crypto devices"
 
-source drivers/crypto/hash/Kconfig
+source "drivers/crypto/hash/Kconfig"
 
-source drivers/crypto/fsl/Kconfig
+source "drivers/crypto/fsl/Kconfig"
 
-source drivers/crypto/aspeed/Kconfig
+source "drivers/crypto/aspeed/Kconfig"
 
-source drivers/crypto/nuvoton/Kconfig
+source "drivers/crypto/nuvoton/Kconfig"
 
 endmenu
diff --git a/drivers/ddr/imx/imx8ulp/Kconfig b/drivers/ddr/imx/imx8ulp/Kconfig
index 42848863aae..90407982de9 100644
--- a/drivers/ddr/imx/imx8ulp/Kconfig
+++ b/drivers/ddr/imx/imx8ulp/Kconfig
@@ -5,7 +5,7 @@ config IMX8ULP_DRAM
 	bool "imx8m dram"
 
 config IMX8ULP_DRAM_PHY_PLL_BYPASS
-	bool "Enable the DDR PHY PLL bypass mode, so PHY clock is from DDR_CLK "
+	bool "Enable the DDR PHY PLL bypass mode, so PHY clock is from DDR_CLK"
 	depends on IMX8ULP_DRAM
 
 config SAVED_DRAM_TIMING_BASE
diff --git a/drivers/pinctrl/intel/Kconfig b/drivers/pinctrl/intel/Kconfig
index 316a8fe27fd..233289c9be8 100644
--- a/drivers/pinctrl/intel/Kconfig
+++ b/drivers/pinctrl/intel/Kconfig
@@ -9,7 +9,7 @@ config INTEL_PINCTRL_DUAL_ROUTE_SUPPORT
 	default y
 
 config INTEL_PINCTRL_PADCFG_PADTOL
-	bool n
+	bool
 
 config INTEL_PINCTRL_IOSTANDBY
 	bool
diff --git a/drivers/usb/host/Kconfig b/drivers/usb/host/Kconfig
index 6213b3c95fa..d7209637479 100644
--- a/drivers/usb/host/Kconfig
+++ b/drivers/usb/host/Kconfig
@@ -252,7 +252,7 @@ endif
 config USB_EHCI_MSM
 	bool "Support for Qualcomm on-chip EHCI USB controller"
 	depends on DM_USB
-	select USB_ULPI_VIEWPORT
+	# select USB_ULPI_VIEWPORT
 	select MSM8916_USB_PHY
 	---help---
 	  Enables support for the on-chip EHCI controller on Qualcomm
diff --git a/lib/Kconfig b/lib/Kconfig
index 549bd357785..efb0cbccc83 100644
--- a/lib/Kconfig
+++ b/lib/Kconfig
@@ -389,7 +389,7 @@ config TRACE_EARLY_ADDR
 config CIRCBUF
 	bool "Enable circular buffer support"
 
-source lib/dhry/Kconfig
+source "lib/dhry/Kconfig"
 
 menu "Security support"
 
@@ -402,10 +402,10 @@ config AES
 	  supported by the algorithm but only a 128-bit key is supported at
 	  present.
 
-source lib/ecdsa/Kconfig
-source lib/rsa/Kconfig
-source lib/crypto/Kconfig
-source lib/crypt/Kconfig
+source "lib/ecdsa/Kconfig"
+source "lib/rsa/Kconfig"
+source "lib/crypto/Kconfig"
+source "lib/crypt/Kconfig"
 
 config TPM
 	bool "Trusted Platform Module (TPM) Support"
@@ -1001,9 +1001,9 @@ config SMBIOS_PARSER
 	help
 	  A simple parser for SMBIOS data.
 
-source lib/efi/Kconfig
-source lib/efi_loader/Kconfig
-source lib/optee/Kconfig
+source "lib/efi/Kconfig"
+source "lib/efi_loader/Kconfig"
+source "lib/optee/Kconfig"
 
 config TEST_FDTDEC
 	bool "enable fdtdec test"
@@ -1071,6 +1071,6 @@ endmenu
 
 menu "FWU Multi Bank Updates"
 
-source lib/fwu_updates/Kconfig
+source "lib/fwu_updates/Kconfig"
 
 endmenu